# -*- coding:Utf-8 -*-
import es, psyco, playerlib, weaponlib, simplemenulib, dm_player
from dm_config import dmConfig
from dm_weapon import dmWeapon
psyco.full()


lastgive = es.ServerVar("eventscripts_lastgive")

def create():
    """
    players = {}
    menulist = simplemenulib.getlist("_dm_python_deathmatch_menu")
    for userid in dm_player.playerlist("human"):
        active = simplemenulib.active(userid)["name"]
        if active:
            players[userid] = menu
            simplemenulib.close(userid, menu)
    """

    simplemenulib.dellist("_dm_python_deathmatch_menu")
    # create deathmatch menu
    try: timeout = int(dmConfig.timeout)
    except ValueError: timeout = 0

    if int(dmConfig.style) == 1:
        menu = simplemenulib.menu("_dm_python_categorie_menu")
        menu.loadlang("cfg/dm_python/language/deathmatch_menu.ini")
        menu.title("main menu title", showpage = False)

        if dmWeapon.pistol:
            menu.addchoice("main option pistol")
            menu.subsimplemenu("main option pistol", "_dm_python_pistol_menu")
            categorie("_dm_python_pistol_menu", "pistol menu title", timeout, dmWeapon.o_pistol, dmWeapon.pistol)

        if dmWeapon.shotgun:
            menu.addchoice("main option shotgun")
            menu.subsimplemenu("main option shotgun", "_dm_python_shotgun_menu")
            categorie("_dm_python_shotgun_menu", "shotgun menu title", timeout, dmWeapon.o_shotgun, dmWeapon.shotgun)

        if dmWeapon.smg:
            menu.addchoice("main option smg")
            menu.subsimplemenu("main option smg", "_dm_python_smg_menu")
            categorie("_dm_python_smg_menu", "smg menu title", timeout, dmWeapon.o_smg, dmWeapon.smg)

        if dmWeapon.rifle:
            menu.addchoice("main option rifle")
            menu.subsimplemenu("main option rifle", "_dm_python_rifle_menu")
            categorie("_dm_python_rifle_menu", "rifle menu title", timeout, dmWeapon.o_rifle, dmWeapon.rifle)

        if dmWeapon.sniper:
            menu.addchoice("main option sniper")
            menu.subsimplemenu("main option sniper", "_dm_python_sniper_menu")
            categorie("_dm_python_sniper_menu", "sniper menu title", timeout, dmWeapon.o_sniper, dmWeapon.sniper)

        menu.addlist("_dm_python_deathmatch_menu")
        menu.addlist("_dm_python_list_menu")
        menu.timeout("view", timeout)

    else:
        if dmWeapon.secondary:
            menu = simplemenulib.menu("_dm_python_secondary_menu")
            menu.loadlang("cfg/dm_python/language/deathmatch_menu.ini")
            menu.title("main menu secondary", showpage = False)

            for weaponName in dmWeapon.o_secondary:
                if weaponName in dmWeapon.secondary:
                    choice = "menu option " + weaponName
                    menu.addchoice(choice, "weapon_" + weaponName)
                    menu.subsimplemenu(choice, "_dm_python_primary_menu")

            menu.addlist("_dm_python_deathmatch_menu")
            menu.addlist("_dm_python_list_menu")
            menu.timeout("view", timeout)
            menu.blockselect = weapon

        if dmWeapon.primary:
            menu = simplemenulib.menu("_dm_python_primary_menu")
            menu.loadlang("cfg/dm_python/language/deathmatch_menu.ini")
            menu.title("main menu primary", showpage = len(dmWeapon.primary) > 8)

            for weaponName in dmWeapon.o_primary:
                if weaponName in dmWeapon.primary:
                    choice = "menu option " + weaponName
                    menu.addchoice(choice, "weapon_" + weaponName)

            if dmWeapon.secondary: menu.simplemenureturn("_dm_python_secondary_menu")
            menu.addlist("_dm_python_deathmatch_menu")
            menu.addlist("_dm_python_list_menu")
            menu.timeout("view", timeout)
            menu.blockselect = weapon

    """
    dmmenulist = simplemenulib.getlist("_dm_python_deathmatch_menu")
    for userid in players:
        if not es.getplayerprop(userid, "CBasePlayer.pl.deadflag"):
            menu = players[userid]
            if simplemenulib.exists(menu): simplemenulib.send(userid, menu)
            else: simplemenulib.send(userid, "_dm_python_categorie_menu")
    """

def categorie(menuId, menuTitle, menuTimeout, weaponOrder, weaponList):
    menu = simplemenulib.menu(menuId)
    menu.loadlang("cfg/dm_python/language/deathmatch_menu.ini")
    menu.title(menuTitle, showpage = False)
    for weaponName in weaponOrder:
        if weaponName in weaponList:
            choice = "menu option " + weaponName
            menu.addchoice(choice, "weapon_" + weaponName)
            menu.subsimplemenu(choice, "_dm_python_categorie_menu")

    menu.simplemenureturn("_dm_python_categorie_menu")
    menu.addlist("_dm_python_deathmatch_menu")
    menu.addlist("_dm_python_list_menu")
    menu.timeout("view", menuTimeout)
    menu.blockselect = weapon

def weapon(userid, index, choice, value, name, page):
    if not es.getplayerprop(userid, "CBasePlayer.pl.deadflag"):
        if value in dmWeapon:
            weapon = weaponlib.getWeapon(value).slot
            user = dm_player.player(userid)
            player = user.player

            if weapon == 1:
                currentweapon = str(player.primary)
                user["lastprimary"] = value
                user.primary = value
            else:
                currentweapon = str(player.secondary)
                user["lastsecondary"] = value
                user.secondary = value

            if currentweapon <> value:
                if currentweapon <> "0":
                    weaponindex = player.getWeaponIndex(currentweapon)
                    if weaponindex <> 0:
                        weapontokill = "_dm_python_current_weapon_to_kill" + str(userid)
                        es.server.queuecmd(
                            "es_xsetentityname %s %s;" % (weaponindex, weapontokill) +
                            "es_xfire %s %s kill" % (userid, weapontokill))
                es.server.queuecmd(
                    "es_xgive %s %s;" % (userid, value)+
                    "es_setentityname server_var(eventscripts_lastgive) " + user.entitiesWeaponsName)
